///
/// HybridImagePerspectiveCropperSpec_cxx.swift
/// This file was generated by nitrogen. DO NOT MODIFY THIS FILE.
/// https://github.com/mrousavy/nitro
/// Copyright © 2025 Marc Rousavy @ Margelo
///

import Foundation
import NitroModules

/**
 * A class implementation that bridges HybridImagePerspectiveCropperSpec over to C++.
 * In C++, we cannot use Swift protocols - so we need to wrap it in a class to make it strongly defined.
 *
 * Also, some Swift types need to be bridged with special handling:
 * - Enums need to be wrapped in Structs, otherwise they cannot be accessed bi-directionally (Swift bug: https://github.com/swiftlang/swift/issues/75330)
 * - Other HybridObjects need to be wrapped/unwrapped from the Swift TCxx wrapper
 * - Throwing methods need to be wrapped with a Result<T, Error> type, as exceptions cannot be propagated to C++
 */
public class HybridImagePerspectiveCropperSpec_cxx {
  /**
   * The Swift <> C++ bridge's namespace (`margelo::nitro::customcrop::bridge::swift`)
   * from `ImagePerspectiveCropper-Swift-Cxx-Bridge.hpp`.
   * This contains specialized C++ templates, and C++ helper functions that can be accessed from Swift.
   */
  public typealias bridge = margelo.nitro.customcrop.bridge.swift

  /**
   * Holds an instance of the `HybridImagePerspectiveCropperSpec` Swift protocol.
   */
  private var __implementation: any HybridImagePerspectiveCropperSpec

  /**
   * Holds a weak pointer to the C++ class that wraps the Swift class.
   */
  private var __cxxPart: bridge.std__weak_ptr_margelo__nitro__customcrop__HybridImagePerspectiveCropperSpec_

  /**
   * Create a new `HybridImagePerspectiveCropperSpec_cxx` that wraps the given `HybridImagePerspectiveCropperSpec`.
   * All properties and methods bridge to C++ types.
   */
  public init(_ implementation: any HybridImagePerspectiveCropperSpec) {
    self.__implementation = implementation
    self.__cxxPart = .init()
    /* no base class */
  }

  /**
   * Get the actual `HybridImagePerspectiveCropperSpec` instance this class wraps.
   */
  @inline(__always)
  public func getHybridImagePerspectiveCropperSpec() -> any HybridImagePerspectiveCropperSpec {
    return __implementation
  }

  /**
   * Casts this instance to a retained unsafe raw pointer.
   * This acquires one additional strong reference on the object!
   */
  public func toUnsafe() -> UnsafeMutableRawPointer {
    return Unmanaged.passRetained(self).toOpaque()
  }

  /**
   * Casts an unsafe pointer to a `HybridImagePerspectiveCropperSpec_cxx`.
   * The pointer has to be a retained opaque `Unmanaged<HybridImagePerspectiveCropperSpec_cxx>`.
   * This removes one strong reference from the object!
   */
  public class func fromUnsafe(_ pointer: UnsafeMutableRawPointer) -> HybridImagePerspectiveCropperSpec_cxx {
    return Unmanaged<HybridImagePerspectiveCropperSpec_cxx>.fromOpaque(pointer).takeRetainedValue()
  }

  /**
   * Gets (or creates) the C++ part of this Hybrid Object.
   * The C++ part is a `std::shared_ptr<margelo::nitro::customcrop::HybridImagePerspectiveCropperSpec>`.
   */
  public func getCxxPart() -> bridge.std__shared_ptr_margelo__nitro__customcrop__HybridImagePerspectiveCropperSpec_ {
    let cachedCxxPart = self.__cxxPart.lock()
    if cachedCxxPart.__convertToBool() {
      return cachedCxxPart
    } else {
      let newCxxPart = bridge.create_std__shared_ptr_margelo__nitro__customcrop__HybridImagePerspectiveCropperSpec_(self.toUnsafe())
      __cxxPart = bridge.weakify_std__shared_ptr_margelo__nitro__customcrop__HybridImagePerspectiveCropperSpec_(newCxxPart)
      return newCxxPart
    }
  }

  

  /**
   * Get the memory size of the Swift class (plus size of any other allocations)
   * so the JS VM can properly track it and garbage-collect the JS object if needed.
   */
  @inline(__always)
  public var memorySize: Int {
    return MemoryHelper.getSizeOf(self.__implementation) + self.__implementation.memorySize
  }

  // Properties
  

  // Methods
  @inline(__always)
  public final func detectRectangleForImage(image: std.string) -> bridge.Result_std__shared_ptr_Promise_Rectangle___ {
    do {
      let __result = try self.__implementation.detectRectangleForImage(image: String(image))
      let __resultCpp = { () -> bridge.std__shared_ptr_Promise_Rectangle__ in
        let __promise = bridge.create_std__shared_ptr_Promise_Rectangle__()
        let __promiseHolder = bridge.wrap_std__shared_ptr_Promise_Rectangle__(__promise)
        __result
          .then({ __result in __promiseHolder.resolve(__result) })
          .catch({ __error in __promiseHolder.reject(__error.toCpp()) })
        return __promise
      }()
      return bridge.create_Result_std__shared_ptr_Promise_Rectangle___(__resultCpp)
    } catch (let __error) {
      let __exceptionPtr = __error.toCpp()
      return bridge.create_Result_std__shared_ptr_Promise_Rectangle___(__exceptionPtr)
    }
  }
  
  @inline(__always)
  public final func cropImage(image: std.string, rectangle: Rectangle) -> bridge.Result_std__shared_ptr_Promise_std__string___ {
    do {
      let __result = try self.__implementation.cropImage(image: String(image), rectangle: rectangle)
      let __resultCpp = { () -> bridge.std__shared_ptr_Promise_std__string__ in
        let __promise = bridge.create_std__shared_ptr_Promise_std__string__()
        let __promiseHolder = bridge.wrap_std__shared_ptr_Promise_std__string__(__promise)
        __result
          .then({ __result in __promiseHolder.resolve(std.string(__result)) })
          .catch({ __error in __promiseHolder.reject(__error.toCpp()) })
        return __promise
      }()
      return bridge.create_Result_std__shared_ptr_Promise_std__string___(__resultCpp)
    } catch (let __error) {
      let __exceptionPtr = __error.toCpp()
      return bridge.create_Result_std__shared_ptr_Promise_std__string___(__exceptionPtr)
    }
  }
}
